UPDATE users SET passwd = 'ekGaihSJjmIL.' WHERE id = '0' AND passwd = 'UNUSED';

CREATE SEQUENCE templates_id_seq;
CREATE TABLE templates (
	id		INT4 NOT NULL DEFAULT nextval('templates_id_seq') PRIMARY KEY,
	objtype		INT2,
	name		VARCHAR(64) NOT NULL,
	descr		TEXT
);
GRANT ALL ON templates TO northstar;

CREATE SEQUENCE fielddefs_id_seq;
CREATE TABLE fielddefs (
	id 		INT4 NOT NULL DEFAULT nextval('fielddefs_id_seq') PRIMARY KEY,
	templateid	INT4,
	name		VARCHAR(64),
	descr		TEXT,
	required	BOOL DEFAULT 'F',
	regex		INT4,
	minlength	INT4,
	maxlength	INT4,
	sortkey		INT4,
	fieldtype	VARCHAR(32),
	fieldopt	VARCHAR(255),
	updatemode	INT2
);
GRANT ALL ON fielddefs TO northstar;

CREATE SEQUENCE regex_id_seq;
CREATE TABLE regex (
	id		INT4 NOT NULL DEFAULT nextval('regex_id_seq') PRIMARY KEY,
	name		VARCHAR(64),
	example		VARCHAR(64),
	regex		VARCHAR(255)
);
GRANT ALL ON regex TO northstar;

CREATE TABLE fielddata (
	id		INT4 NOT NULL,
	fieldid		INT4 NOT NULL,
	data		TEXT
);
GRANT ALL ON fielddata TO northstar;	

INSERT INTO templates VALUES('0','0','Default Template','Default Template');
INSERT INTO templates VALUES('1','1','Default Owner Template','Default Owner Template');
INSERT INTO templates VALUES('2','2','Default Location Template','Default Location Template');
INSERT INTO templates VALUES('3','3','Default Device Template','Default Device Template');
INSERT INTO templates VALUES('4','4','Default Network Template','Default Network Template');
INSERT INTO templates VALUES('5','5','Default Address Template','Default Address Template');

INSERT INTO regex VALUES('1','email','xxx@yyy.zzz','([\w\-\.\+]+)\@([\w\-\.]+)\.(\w{3}|\w{2})');
INSERT INTO regex VALUES('2','phone','111-222-333','^[\d\-\(\)\ ]+$');
INSERT INTO regex VALUES('3','state','XX','([.\w{2}])');
INSERT INTO regex VALUES('4','zip','55555','([.\d{5}])');
INSERT INTO regex VALUES('5','ziplong','55555-4444','([.\d{5}]\-[.\d{4}])');
INSERT INTO regex VALUES('6','zipboth','55555, 55555-4444','^(\d{5}\-\d{4}|\d{5})$');
INSERT INTO regex VALUES('7','alpha','A-Z, a-z, 0-9, .#&,\'-@,','^[\d\w\ \.\#\&\,\'\-\n\@\,\W]+$');
INSERT INTO regex VALUES('8','num','0-9','^\d+$');
INSERT INTO regex VALUES('9','date','mm-dd-yy','^(\d{1,2}\/\d{1,2}\/\d{2})$');
INSERT INTO regex VALUES('10','ipv4addr','255.255.255.255','^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$');
INSERT INTO regex VALUES('11','cidraddr','10.0.0.0/8','^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+\/\d+$');
INSERT INTO regex VALUES('12','macaddr','00:22:55:aa:bb:ff','^[0-9a-f]{2}\:[0-9a-f]{2}\:[0-9a-f]{2}\:[0-9a-f]{2}\:[0-9a-f]{2}\:[0-9a-f]{2}$');

INSERT INTO fielddefs VALUES('1','5','MAC Address','MAC Address of the interface using this address','F',
                             '12','0','20','1','TEXT','','2');
INSERT INTO fielddefs VALUES('2','1','Street Address','Street Address of the Owner','T','7','0','100','1','TEXT','','2');
INSERT INTO fielddefs VALUES('3','1','City','City of the Owner','T','7','0','100','2','TEXT','','2');
INSERT INTO fielddefs VALUES('4','1','State','State of the Owner','F','3','0','50','3','TEXT','','2');
INSERT INTO fielddefs VALUES('5','1','Zip/Postal Code','Zip Code of the Owner','T','6','0','50','4','TEXT','','2');
INSERT INTO fielddefs VALUES('6','1','POC Name','Point of Contact Name','T','7','0','50','5','TEXT','','2');
INSERT INTO fielddefs VALUES('7','1','POC Email','Point of Contact Email','T','1','0','50','6','TEXT','','2');
INSERT INTO fielddefs VALUES('8','1','POC Phone','Point of Contact Phone','T','2','0','50','7','TEXT','','2');
INSERT INTO fielddefs VALUES('9','1','POC Pager','Point of Contact Pager','T','2','0','50','8','TEXT','','2');
INSERT INTO fielddefs VALUES('10','1','POC Cell','Point of Contact Cell','T','2','0','50','9','TEXT','','2');
INSERT INTO fielddefs VALUES('11','1','Tech Name','Tech Point of Contact Name','T','7','0','50','10','TEXT','','2');
INSERT INTO fielddefs VALUES('12','1','Tech Email','Tech Point of Contact Email','T','1','0','50','11','TEXT','','2');
INSERT INTO fielddefs VALUES('13','1','Tech Phone','Tech Point of Contact Phone','T','2','0','50','12','TEXT','','2');
INSERT INTO fielddefs VALUES('14','1','Tech Pager','Tech Point of Contact Pager','T','2','0','50','13','TEXT','','2');
INSERT INTO fielddefs VALUES('15','1','Tech Cell','Tech Point of Contact Cell','T','2','0','50','14','TEXT','','2');

INSERT INTO fielddata SELECT id, 2 as fieldid, address FROM owners;
INSERT INTO fielddata SELECT id, 3 as fieldid, city FROM owners;
INSERT INTO fielddata SELECT id, 4 as fieldid, state FROM owners;
INSERT INTO fielddata SELECT id, 5 as fieldid, zip FROM owners;
INSERT INTO fielddata SELECT id, 6 as fieldid, pocname FROM owners;
INSERT INTO fielddata SELECT id, 7 as fieldid, pocemail FROM owners;
INSERT INTO fielddata SELECT id, 8 as fieldid, pocphone FROM owners;
INSERT INTO fielddata SELECT id, 9 as fieldid, pocpager FROM owners;
INSERT INTO fielddata SELECT id, 10 as fieldid, poccell FROM owners;
INSERT INTO fielddata SELECT id, 11 as fieldid, techname FROM owners;
INSERT INTO fielddata SELECT id, 12 as fieldid, techemail FROM owners;
INSERT INTO fielddata SELECT id, 13 as fieldid, techphone FROM owners;
INSERT INTO fielddata SELECT id, 14 as fieldid, techpager FROM owners;
INSERT INTO fielddata SELECT id, 15 as fieldid, techcell FROM owners;

CREATE TABLE owners_old AS SELECT
	id, 1+0 as templateid, name, descr 
FROM owners;
DROP TABLE owners;
CREATE TABLE owners (
	id              INT4 NOT NULL DEFAULT nextval('owners_id_seq') PRIMARY KEY,  	
	templateid	INT4 NOT NULL DEFAULT '1',
	name		VARCHAR(256) NOT NULL,
	descr		TEXT
);
INSERT INTO owners SELECT * FROM owners_old;
DROP TABLE owners_old;
GRANT ALL ON owners TO northstar;


CREATE TABLE locations_old AS SELECT 
	id, parent, 2+0 as templateid, name, descr, assignuser, assigndate,
	updateuser, upddate 
FROM locations;
DROP TABLE locations;
CREATE TABLE locations (
	id              INT4 NOT NULL DEFAULT nextval('locations_id_seq') PRIMARY KEY,    
	parent		INT4 NOT NULL REFERENCES locations(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE DEFAULT '0',	
	templateid	INT4 NOT NULL DEFAULT '2',
	name		VARCHAR(256) NOT NULL,
	descr		TEXT,
	assignuser	INT4 REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	assigndate	TIMESTAMP DEFAULT now(),
	updateuser	INT4 REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	upddate		TIMESTAMP DEFAULT now()
);
INSERT INTO locations SELECT * FROM locations_old;
DROP TABLE locations_old;
GRANT ALL ON locations TO northstar;


CREATE TABLE devices_old AS SELECT 
	id, parent, 3+0 as templateid, name, descr, owner, location, assignuser,
	assigndate, updateuser, upddate 
FROM devices;
DROP TABLE devices;
CREATE TABLE devices (
	id		INT4 NOT NULL DEFAULT nextval('devices_id_seq') PRIMARY KEY, 
	parent		INT4 NOT NULL REFERENCES devices(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE DEFAULT '0',	
	templateid	INT4 NOT NULL DEFAULT '3',
	name		VARCHAR(256) NOT NULL,
	descr		TEXT,
	owner		INT4 NOT NULL REFERENCES owners(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE, 
	location	INT4 NOT NULL REFERENCES locations(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE, 
	assignuser	INT4 NOT NULL REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	assigndate	TIMESTAMP DEFAULT now(),
	updateuser	INT4 REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	upddate		TIMESTAMP DEFAULT now()
);
INSERT INTO devices SELECT * FROM devices_old;
DROP TABLE devices_old;
GRANT ALL ON devices TO northstar;

CREATE TABLE networks_old AS SELECT
	id, parent, 4+0 as templateid, name, descr, label, network, masklen, 
	owner, device, assignuser, assigndate, updateuser, upddate 
FROM networks;
DROP TABLE networks;
CREATE TABLE networks (
	id		INT4 NOT NULL DEFAULT nextval('networks_id_seq') PRIMARY KEY,
	parent		INT4 NOT NULL REFERENCES networks(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE DEFAULT '0',
	templateid	INT4 NOT NULL DEFAULT '4',
	name		VARCHAR(256) NOT NULL,
	descr		TEXT,
	label		VARCHAR(256) NOT NULL,
	network		NUMERIC(40,0) NOT NULL,
	masklen		INT4 NOT NULL,
	owner		INT4 NOT NULL REFERENCES owners(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,
	device		INT4 NOT NULL REFERENCES devices(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,
	assignuser	INT4 NOT NULL REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	assigndate	TIMESTAMP DEFAULT now(),
	updateuser	INT4 REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	upddate		TIMESTAMP DEFAULT now()
);
INSERT INTO networks SELECT * FROM networks_old;
DROP TABLE networks_old;
GRANT ALL ON networks TO northstar;


CREATE TABLE addresses_old AS SELECT
	id, parent, 5+0 as templateid, address, owner, device, dnsname,
	misc, assignuser, assigndate, updateuser, upddate 
FROM addresses;
DROP TABLE addresses;
CREATE TABLE addresses (
	id              INT4 NOT NULL DEFAULT nextval('addresses_id_seq') PRIMARY KEY,        
	parent		INT4 NOT NULL REFERENCES networks(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,
	templateid	INT4 NOT NULL DEFAULT '5',
	address		VARCHAR(256) NOT NULL,
	owner		INT4 NOT NULL REFERENCES owners(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,  
	device		INT4 NOT NULL REFERENCES devices(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,     
	dnsname		VARCHAR(128),
	misc		TEXT,
	assignuser	INT4 NOT NULL REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	assigndate	TIMESTAMP DEFAULT now(),
	updateuser	INT4 REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	upddate		TIMESTAMP DEFAULT now()
);
INSERT INTO addresses SELECT * FROM addresses_old;
DROP TABLE addresses_old;
GRANT ALL ON addresses TO northstar;




