
DROP TABLE sessions;
CREATE TABLE sessions (
 	id		VARCHAR(32) NOT NULL PRIMARY KEY,
 	date		NUMERIC(40,0),
 	username	VARCHAR(32) NOT NULL,
 	ip		VARCHAR(20)
);

CREATE TABLE auditlog (
	id		INT4 NOT NULL AUTO_INCREMENT PRIMARY KEY,
 	date		TIMESTAMP,
 	username	VARCHAR(64),
 	section		VARCHAR(25),
 	action		VARCHAR(25),
 	msg		TEXT
);

UPDATE users SET permmask = '1111111111111111111111111111111XXXXXXXX111X11111111111111111111XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX' WHERE id = '0';

CREATE TABLE views (
	id		INT4 NOT NULL AUTO_INCREMENT PRIMARY KEY,
	name		VARCHAR(64),
	descr		TEXT
);
INSERT INTO views (name,descr) VALUES ('Default View','This is the default view from the 1.4 update script');


CREATE TABLE networks_old AS SELECT
	id, parent, templateid, 0+1 as viewid, name, descr, label, network,
	masklen, owner, device, assignuser, assigndate, updateuser, upddate 
FROM networks;
DROP TABLE networks;

CREATE TABLE networks (
	id		INT4 NOT NULL AUTO_INCREMENT PRIMARY KEY,
	parent		INT4 NOT NULL DEFAULT '0' REFERENCES networks(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,
	templateid	INT4 NOT NULL DEFAULT '4',
	viewid		INT4 NOT NULL DEFAULT '1',
	name		VARCHAR(255) NOT NULL,
	descr		TEXT,
	label		VARCHAR(255) NOT NULL,
	network		NUMERIC(40,0) NOT NULL,
	masklen		INT4 NOT NULL,
	owner		INT4 NOT NULL REFERENCES owners(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,
	device		INT4 NOT NULL REFERENCES devices(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,
	assignuser	INT4 NOT NULL REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	assigndate	TIMESTAMP,
	updateuser	INT4 REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	upddate		TIMESTAMP
);
INSERT INTO networks SELECT * FROM networks_old WHERE id = 0;
UPDATE networks SET id = '0' WHERE label = '0.0.0.0/0';
INSERT INTO networks SELECT * FROM networks_old WHERE id != 0;

DROP TABLE networks_old;

CREATE TABLE addresses_old AS SELECT
	id, parent, templateid, 0+1 as viewid, address, owner, device, dnsname,
	misc, assignuser, assigndate, updateuser, upddate 
FROM addresses;
DROP TABLE addresses;

CREATE TABLE addresses (
	id              INT4 NOT NULL AUTO_INCREMENT PRIMARY KEY,        
	parent		INT4 NOT NULL REFERENCES networks(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,
	templateid	INT4 NOT NULL DEFAULT '5',
	viewid		INT4 NOT NULL,
	address		VARCHAR(255) NOT NULL,
	owner		INT4 NOT NULL REFERENCES owners(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,  
	device		INT4 NOT NULL REFERENCES devices(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,     
	dnsname		VARCHAR(128),
	misc		TEXT,
	assignuser	INT4 NOT NULL REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	assigndate	TIMESTAMP,
	updateuser	INT4 REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	upddate		TIMESTAMP
);
INSERT INTO addresses SELECT * FROM addresses_old;
DROP TABLE addresses_old;

