
DROP TABLE sessions;
CREATE TABLE sessions (
 	id		VARCHAR(32) NOT NULL PRIMARY KEY,
 	date		NUMERIC(40,0),
 	username	VARCHAR(32) NOT NULL,
 	ip		VARCHAR(20)
);
GRANT ALL ON sessions TO northstar;

CREATE SEQUENCE auditlog_id_seq;
CREATE TABLE auditlog (
	id		INT4 NOT NULL DEFAULT nextval('auditlog_id_seq') PRIMARY KEY,
 	date		TIMESTAMP DEFAULT NOW(),
 	username	VARCHAR(64),
 	section		VARCHAR(25),
 	action		VARCHAR(25),
 	msg		TEXT
);
GRANT ALL ON auditlog TO northstar;

UPDATE USERS SET permmask = '1111111111111111111111111111111XXXXXXXX111X11111111111111111111XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX' WHERE id = '0';

CREATE SEQUENCE views_id_seq START 2;
CREATE TABLE views (
	id		INT4 NOT NULL DEFAULT nextval('views_id_seq') PRIMARY KEY,
	name		VARCHAR(64),
	descr		TEXT
);
GRANT ALL ON views TO northstar;
INSERT INTO views VALUES ('1','Default View','This is the default view from the 1.4 update script');


CREATE TABLE networks_old AS SELECT
	id, parent, templateid, 0+1 as viewid, name, descr, label, network,
	masklen, owner, device, assignuser, assigndate, updateuser, upddate 
FROM networks;
DROP TABLE networks;

CREATE TABLE networks (
	id		INT4 NOT NULL DEFAULT nextval('networks_id_seq') PRIMARY KEY,
	parent		INT4 NOT NULL REFERENCES networks(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE DEFAULT '0',
	templateid	INT4 NOT NULL DEFAULT '4',
	viewid		INT4 NOT NULL DEFAULT '1',
	name		VARCHAR(256) NOT NULL,
	descr		TEXT,
	label		VARCHAR(256) NOT NULL,
	network		NUMERIC(40,0) NOT NULL,
	masklen		INT4 NOT NULL,
	owner		INT4 NOT NULL REFERENCES owners(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,
	device		INT4 NOT NULL REFERENCES devices(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,
	assignuser	INT4 NOT NULL REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	assigndate	TIMESTAMP DEFAULT now(),
	updateuser	INT4 REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	upddate		TIMESTAMP DEFAULT now()
);
INSERT INTO networks SELECT * FROM networks_old;
DROP TABLE networks_old;
GRANT ALL ON networks TO northstar;


CREATE TABLE addresses_old AS SELECT
	id, parent, templateid, 0+1 as viewid, address, owner, device, dnsname,
	misc, assignuser, assigndate, updateuser, upddate 
FROM addresses;
DROP TABLE addresses;

CREATE TABLE addresses (
	id              INT4 NOT NULL DEFAULT nextval('addresses_id_seq') PRIMARY KEY,        
	parent		INT4 NOT NULL REFERENCES networks(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,
	templateid	INT4 NOT NULL DEFAULT '5',
	viewid		INT4 NOT NULL,
	address		VARCHAR(256) NOT NULL,
	owner		INT4 NOT NULL REFERENCES owners(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,  
	device		INT4 NOT NULL REFERENCES devices(id) MATCH FULL ON DELETE CASCADE ON UPDATE CASCADE,     
	dnsname		VARCHAR(128),
	misc		TEXT,
	assignuser	INT4 NOT NULL REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	assigndate	TIMESTAMP DEFAULT now(),
	updateuser	INT4 REFERENCES users(id) MATCH FULL ON UPDATE CASCADE,
	upddate		TIMESTAMP DEFAULT now()
);
INSERT INTO addresses SELECT * FROM addresses_old;
DROP TABLE addresses_old;
GRANT ALL ON addresses TO northstar;

